import gleam/result
import kicad_sexpr/decode
import kicad_sexpr/parse
import kicad_sexpr/token

pub type ParseDecodeError {
  ParseError(parse.ParseError)
  DecodeError(decode.DecodeError)
}

pub fn parse_decode(
  data: BitArray,
  decoder: decode.Decoder(a),
) -> Result(a, ParseDecodeError) {
  use sexpr <- result.try(parse.run(data) |> result.map_error(ParseError))
  decode.run(decoder, sexpr) |> result.map_error(DecodeError)
}

pub fn parse_footprint_file(
  data: BitArray,
) -> Result(token.FootprintFile, ParseDecodeError) {
  parse_decode(data, token.footprint_file(decode.success))
}

pub fn parse_symbol_library(
  data: BitArray,
) -> Result(token.SymbolLibrary, ParseDecodeError) {
  parse_decode(data, token.symbol_library(decode.success))
}
